#ifndef _IL9163C_H
#define _IL9163C_H


#define	ILI9163C_GLEBIA		4
#define _TFTWIDTH  		128	//the REAL W resolution of the TFT
#define _TFTHEIGHT 		128	//160//the REAL H resolution of the TFT
#define _GRAMWIDTH    128
#define _GRAMHEIGH    128	//160
#define _GRAMSIZE		(_GRAMWIDTH * _GRAMHEIGH)		//*see note 1
#define __COLORSPC		0	// 1:GBR - 0:RGB
#define __GAMMASET1			//uncomment for another gamma
#define __OFFSET		0		//*see note 2


#define	LCD_ILI9163C_SPI_TYPE		1
#define	HARD_SPI					SPI1		// Numer portu SPI
//#define	LCD_HARD_RST
#define	FONT_16x32_OFF


#define	TFT_MODE_PROP				1		// Czcionka proporcjonalna
#define	TFT_MODE_TXT_BACK		2		// czcionka z tlem


// Color definitions
#define IL9163_RGB(B,G,R)  (((R >> 3) << 11) | ((G >> 2) << 5) | (B >> 3))
#define IL9163_BLACK   0x0000
#define IL9163_BLUE    IL9163_RGB(0,0,255)
#define IL9163_RED     IL9163_RGB(255,0,0)
#define IL9163_GREEN   IL9163_RGB(0,255,0)
#define IL9163_CYAN    IL9163_RGB(0,255,255)
#define IL9163_MAGNETA IL9163_RGB(255,0,255)
#define IL9163_YELLOW  IL9163_RGB(255,255,0)
#define IL9163_WHITE   0xFFFF


//ILI9163C registers-----------------------
#define CMD_NOP     	0x00//Non operation
#define CMD_SWRESET 	0x01//Soft Reset
#define CMD_SLPIN   	0x10//Sleep ON
#define CMD_SLPOUT  	0x11//Sleep OFF
#define CMD_PTLON   	0x12//Partial Mode ON
#define CMD_NORML   	0x13//Normal Display ON
#define CMD_DINVOF  	0x20//Display Inversion OFF
#define CMD_DINVON   	0x21//Display Inversion ON
#define CMD_GAMMASET 	0x26//Gamma Set (0x01[1],0x02[2],0x04[3],0x08[4])
#define CMD_DISPOFF 	0x28//Display OFF
#define CMD_DISPON  	0x29//Display ON
#define CMD_IDLEON  	0x39//Idle Mode ON
#define CMD_IDLEOF  	0x38//Idle Mode OFF
#define CMD_CLMADRS   	0x2A//Column Address Set
#define CMD_PGEADRS   	0x2B//Page Address Set

#define CMD_RAMWR   	0x2C//Memory Write
#define CMD_RAMRD   	0x2E//Memory Read
#define CMD_CLRSPACE   	0x2D//Color Space : 4K/65K/262K
#define CMD_PARTAREA	0x30//Partial Area
#define CMD_VSCLLDEF	0x33//Vertical Scroll Definition
#define CMD_TEFXLON		0x35//Tearing Effect Line ON
#define CMD_TEFXLOF		0x34//Tearing Effect Line OFF
#define CMD_MADCTL  	0x36//Memory Access Control
#define CMD_VSSTADRS	0x37//Vertical Scrolling Start address
#define CMD_PIXFMT  	0x3A//Interface Pixel Format
#define CMD_FRMCTR1 	0xB1//Frame Rate Control (In normal mode/Full colors)
#define CMD_FRMCTR2 	0xB2//Frame Rate Control(In Idle mode/8-colors)
#define CMD_FRMCTR3 	0xB3//Frame Rate Control(In Partial mode/full colors)
#define CMD_DINVCTR		0xB4//Display Inversion Control
#define CMD_RGBBLK		0xB5//RGB Interface Blanking Porch setting
#define CMD_DFUNCTR 	0xB6//Display Fuction set 5
#define CMD_SDRVDIR 	0xB7//Source Driver Direction Control
#define CMD_GDRVDIR 	0xB8//Gate Driver Direction Control 

#define CMD_PWCTR1  	0xC0//Power_Control1
#define CMD_PWCTR2  	0xC1//Power_Control2
#define CMD_PWCTR3  	0xC2//Power_Control3
#define CMD_PWCTR4  	0xC3//Power_Control4
#define CMD_PWCTR5  	0xC4//Power_Control5
#define CMD_VCOMCTR1  	0xC5//VCOM_Control 1
#define CMD_VCOMCTR2  	0xC6//VCOM_Control 2
#define CMD_VCOMOFFS  	0xC7//VCOM Offset Control
#define CMD_PGAMMAC		0xE0//Positive Gamma Correction Setting
#define CMD_NGAMMAC		0xE1//Negative Gamma Correction Setting
#define CMD_GAMRSEL		0xF2//GAM_R_SEL


void TFT_ILI9163C_SenSPI(uint8_t c);
void TFT_ILI9163C_writecommand(uint8_t c);
void TFT_ILI9163C_writedata(uint8_t c);
void TFT_ILI9163C_writedata16(uint16_t d);
void TFT_ILI9163C_colorSpace(uint8_t cspace);
extern void TFT_ILI9163C_chipInit(uint8_t mode);
extern void TFT_ILI9163C_invertDisplay(uint8_t i);
extern void TFT_ILI9163C_idleMode(uint8_t onOff);
extern void TFT_ILI9163C_sleepMode(uint8_t mode);
extern void TFT_ILI9163C_defineScrollArea(uint16_t tfa, uint16_t bfa);
extern void TFT_ILI9163C_scroll(uint16_t adrs);
extern void TFT_ILI9163C_clearScreen(uint16_t color);
extern void TFT_ILI9163C_startPushData(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1);
extern void TFT_ILI9163C_pushData(uint16_t color);
extern void TFT_ILI9163C_endPushData(void);
extern void TFT_ILI9163C_pushColor(uint16_t color);
extern void TFT_ILI9163C_writeScreen24(const uint32_t *bitmap,uint16_t size);
extern void TFT_ILI9163C_homeAddress(void);
extern void TFT_ILI9163C_drawRGBBitmap(int16_t x, int16_t y,  uint16_t *bitmap, int16_t w, int16_t h);
extern void TFT_ILI9163C_setCursor(int16_t x, int16_t y);
extern void TFT_ILI9163C_drawPixel(int16_t x, int16_t y, uint16_t color);
extern void TFT_ILI9163C_drawFastVLine(int16_t x, int16_t y, int16_t h, uint16_t color);
extern void TFT_ILI9163C_drawLine(int16_t x0, int16_t y0,int16_t x1, int16_t y1, uint16_t color);
extern uint8_t TFT_ILI9163C_boundaryCheck(int16_t x,int16_t y);
extern void TFT_ILI9163C_drawFastHLine(int16_t x, int16_t y, int16_t w, uint16_t color);
extern void TFT_ILI9163C_fillScreen(uint16_t color);
extern void TFT_ILI9163C_fillRect(int16_t x, int16_t y, int16_t w, int16_t h, uint16_t color);
extern void TFT_ILI9163C_setAddr(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1);
extern void TFT_ILI9163C_setAddrWindow(uint16_t x0, uint16_t y0, uint16_t x1, uint16_t y1);
extern void TFT_ILI9163C_setRotation(uint8_t m);
extern void TFT_ILI9163C_setRotation4dma(uint8_t m);
extern void TFT_ILI9163C_CsInactive(void);
extern void TFT_ILI9163C_WaitDMA(void);
extern uint8_t TFT_ILI9163C_TestDMA(void);
extern void TFT_ILI9163C_Display(void);
extern void TFT_ILI9163C_DisplayDMA(void);
void TFT_ILI9163C_writeBuf( uint16_t x, uint16_t y, uint16_t color );
void TFT_ILI9163C_SwapColor( uint16_t *color );
extern int TFT_ILI9163C_PrintString_(int x, int y, char *text, uint16_t color, uint16_t tlo,uint8_t mode );
extern int TFT_ILI9163C_PrintString(int x, int y, char *text, uint16_t color );
extern int TFT_ILI9163C_PrintString_B(int x, int y, char *text, uint16_t color, uint16_t tlo );
extern int TFT_ILI9163C_PrintString_P(int x, int y, char *text, uint16_t color );
extern int TFT_ILI9163C_PrintString_BP(int x, int y, char *text, uint16_t color, uint16_t tlo );
extern int TFT_ILI9163C_DrawFont(int x, int y, char znak, uint16_t color, uint16_t tlo, uint8_t mode );
extern uint8_t TFT_ILI9163C_GetFontSizeY(void);
extern uint8_t TFT_ILI9163C_GetFontSizeX(void);
extern void TFT_ILI9163C_SetFont( uint8_t x, uint8_t y );
extern void TFT_ILI9163C_drawCircle(int x0, int y0, uint8_t rad, uint8_t option, uint16_t color );


#define	TFT_ILI9163C_WaitBusy		TFT_ILI9163C_WaitDMA
#define	TFT_ILI9163C_BusyTest		TFT_ILI9163C_TestDMA


#define DRAW_UPPER_RIGHT 0x01
#define DRAW_UPPER_LEFT  0x02
#define DRAW_LOWER_LEFT 0x04
#define DRAW_LOWER_RIGHT  0x08
#define DRAW_ALL (DRAW_UPPER_RIGHT | DRAW_UPPER_LEFT | DRAW_LOWER_RIGHT | DRAW_LOWER_LEFT)


#endif
